(* EPITA SPE 2009/2010       *)
(* Control 1 - Novembre 2009 *)
(* question12.ml             *)

module Q = Question12

let rec make_tree getN =
  function
      0 -> Q.Empty
    | n -> Q.Node (
	make_tree getN (n-1),
	getN (),
	make_tree getN (n-1)
      )

let newName =
  let c = ref 0 in
    fun _ ->
      incr c;
      "node" ^ string_of_int (!c)

let dot_from_tree fo t =
  let rec tree_to_dot nodeName =
    function
	Q.Empty -> ()
      | Q.Node (Q.Empty,k,Q.Empty) ->
	  Format.fprintf fo "@;%s [label=\"%d\"];" nodeName k
      | Q.Node (ls,k,rs) ->
	  let nls, nrs = newName (), newName () in
	    begin
	      Format.fprintf fo "@;%s [label=\"%d\"];" nodeName k;
	      Format.fprintf fo "@;%s -> %s;" nodeName nls;
	      Format.fprintf fo "@;%s -> %s;" nodeName nrs;
	      tree_to_dot nls ls;
	      tree_to_dot nrs rs;
	    end
  in
    Format.fprintf fo "@[<v 2>digraph Tree {";
    Format.fprintf fo "@; node [shape=\"circle\"];";
    tree_to_dot "node0" t;
    Format.fprintf fo "@]@;}@."

let rec print_tree =
  function
      Q.Empty -> Format.printf "Empty"
    | Q.Node (ls,k,rs) ->
	begin
	  Format.printf "@[<b 1>Node(@,";
	  print_tree ls;
	  Format.printf ",@;%02d,@;" k;
	  print_tree rs;
	  Format.printf "@]@,)";
	end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 12 100 in
      q#beginParse;
      q#init;
      let t = make_tree (fun _ -> q#getN) (q#getSize + 1) in
(*       let dot = open_out_gen *)
(* 	[Open_wronly;Open_creat;Open_trunc] *)
(* 	0o666 *)
(* 	"tree.dot" *)
(*       in *)
(* 	dot_from_tree (Format.formatter_of_out_channel dot) t; *)
(* 	close_out dot; *)
	Format.printf "@[<b 0>t =@;";
	print_tree t;
	Format.printf "@]@.";
	Format.printf "@[<b 2>to_parstring t =@;%S@]@."
	  (Q.to_parstring string_of_int t);
  end

let _ = main ()
